blob: accc42bce8c7a8a7adef7268e359a5227577b707 (
plain) (
blame)
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
|
diff --git a/modules.d/98dracut-systemd/dracut-emergency.sh b/modules.d/98dracut-systemd/dracut-emergency.sh
index c6637a5c..19fc4948 100755
--- a/modules.d/98dracut-systemd/dracut-emergency.sh
+++ b/modules.d/98dracut-systemd/dracut-emergency.sh
@@ -42,6 +42,11 @@ else
[ -z "$_emergency_action" ] && _emergency_action=halt
fi
+if ! getarg splash; then
+ # Enable systemd output again
+ /bin/kill -SIGRTMIN+20 1
+fi
+
/bin/rm -f -- /.console_lock
case "$_emergency_action" in
diff --git a/modules.d/99base/dracut-lib.sh b/modules.d/99base/dracut-lib.sh
index 39609d82..8e28789a 100755
--- a/modules.d/99base/dracut-lib.sh
+++ b/modules.d/99base/dracut-lib.sh
@@ -945,7 +945,13 @@ _emergency_shell() {
fi
[ -c "$_ctty" ] || _ctty=/dev/tty1
case "$(/usr/bin/setsid --help 2>&1)" in *--ctty*) CTTY="--ctty" ;; esac
+ : > /.console_lock
setsid $CTTY /bin/sh -i -l 0<> $_ctty 1<> $_ctty 2<> $_ctty
+ rm -f -- /.console_lock
+ if ! getarg splash; then
+ # Enable systemd output again
+ /bin/kill -SIGRTMIN+20 1
+ fi
fi
}
@@ -955,6 +961,8 @@ emergency_shell() {
local _rdshell_name="dracut" action="Boot" hook="emergency"
local _emergency_action
+ [ -e /.console_lock ] && return 0
+
if [ "$1" = "-n" ]; then
_rdshell_name=$2
shift 2
@@ -964,11 +972,16 @@ emergency_shell() {
hook="shutdown-emergency"
shift 2
fi
-
- echo
- echo
- warn "$*"
- echo
+ {
+ # clear fbsplash
+ if getarg splash; then
+ echo -en '\033[2J'
+ fi
+ echo "$*"
+ echo
+ } > /dev/tty1
+ # Disable systemd output
+ /bin/kill -SIGRTMIN+21 1
_emergency_action=$(getarg rd.emergency)
[ -z "$_emergency_action" ] \
@@ -981,6 +994,16 @@ emergency_shell() {
source_hook "$hook"
warn "$action has failed. To debug this issue add \"rd.shell rd.debug\" to the kernel command line."
[ -z "$_emergency_action" ] && _emergency_action=halt
+ local delay=60
+ {
+ echo "FATAL - contact your bwLehrpool administrator."
+ while [ "$delay" -gt 0 ]; do
+ echo -e "System will ${_emergency_action} in $delay seconds or upon key press."'\e[1A\e[K'
+ (( delay-- ))
+ sleep 1
+ done &
+ } > /dev/tty1
+ read -s -t 60 -n 1 bs < /dev/tty1
fi
case "$_emergency_action" in
|